## grive 0.2.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)

set( GRIVE_VERSION "0.2.0" )

add_subdirectory( libgrive )
add_subdirectory( grive )

=== grive/CMakeLists.txt ===
project( grive )

find_package(Boost COMPONENTS program_options REQUIRED)

include_directories(
	${grive_SOURCE_DIR}/../libgrive/src
	${OPT_INCS}
)

add_definitions( -DVERSION="${GRIVE_VERSION}" )

file (GLOB GRIVE_EXE_SRC
    ${grive_SOURCE_DIR}/src/*.cc
)

add_executable( grive_executable
	${GRIVE_EXE_SRC}
)

target_link_libraries( grive_executable
	${Boost_LIBRARIES}
    grive
)

set_target_properties( grive_executable
    PROPERTIES OUTPUT_NAME grive
)

install(TARGETS grive_executable RUNTIME DESTINATION bin)
install(FILES doc/grive.1 DESTINATION share/man/man1 )

=== libgrive/CMakeLists.txt ===
project(libgrive)

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_SOURCE_DIR}/cmake/Modules/")

find_package(LibGcrypt REQUIRED)
find_package(JSONC REQUIRED)
find_package(CURL REQUIRED)
find_package(EXPAT REQUIRED)
find_package(Boost 1.40.0 COMPONENTS filesystem system REQUIRED)
find_package(BFD)
find_package(CppUnit)
find_package(Iberty)
find_package(ZLIB)

# additional headers if build unit tests
IF ( CPPUNIT_FOUND )
	set( OPT_INCS		${CPPUNIT_INCLUDE_DIR} )
ENDIF ( CPPUNIT_FOUND )

# build bfd classes if libbfd is found
if ( BFD_FOUND )
	set( OPT_LIBS	${DL_LIBRARY} ${BFD_LIBRARY} )
	file( GLOB OPT_SRC
		src/bfd/*.cc
	)
	add_definitions( -DHAVE_BFD )
	
endif ( BFD_FOUND )

if ( IBERTY_FOUND )
	set( OPT_LIBS	${OPT_LIBS}	${IBERTY_LIBRARY} )
endif ( IBERTY_FOUND )

if ( ZLIB_FOUND )
	set( OPT_LIBS	${OPT_LIBS}	${ZLIB_LIBRARIES} )
endif ( ZLIB_FOUND )

include_directories(
	${libgrive_SOURCE_DIR}/src
	${libgrive_SOURCE_DIR}/test
	${GDBM_INCLUDE_DIR}
	${OPT_INCS}
)

file(GLOB DRIVE_HEADERS
    ${libgrive_SOURCE_DIR}/src/drive/*.hh
)

file (GLOB PROTOCOL_HEADERS
    ${libgrive_SOURCE_DIR}/src/protocol/*.hh
)

file (GLOB UTIL_HEADERS
    ${libgrive_SOURCE_DIR}/src/util/*.hh
)

file (GLOB XML_HEADERS
    ${libgrive_SOURCE_DIR}/src/xml/*.hh
)

file (GLOB LIBGRIVE_SRC
	src/drive/*.cc
	src/http/*.cc
	src/protocol/*.cc
	src/util/*.cc
	src/util/log/*.cc
	src/xml/*.cc
)

add_definitions(
	-DVERSION="${GRIVE_VERSION}"
	-DTEST_DATA="${libgrive_SOURCE_DIR}/test/data/"
	-DSRC_DIR="${libgrive_SOURCE_DIR}/src"
)

#add_library( grive SHARED ${LIBGRIVE_SRC} ${OPT_SRC} )
add_library( grive STATIC ${LIBGRIVE_SRC} ${OPT_SRC} )

target_link_libraries( grive
	${CURL_LIBRARIES}
	${JSONC_LIBRARY}
	${LIBGCRYPT_LIBRARIES}
	${GDBM_LIBRARIES}
	${Boost_LIBRARIES}
	${IBERTY_LIBRARY}
	${EXPAT_LIBRARY}
	${OPT_LIBS}
)

#set_target_properties(grive PROPERTIES
#    SOVERSION 0 VERSION ${GRIVE_VERSION}
#)

#set_target_properties(grive grive-static PROPERTIES OUTPUT_NAME grive)

if ( LIB_INSTALL_DIR )
else()
	set ( LIB_INSTALL_DIR ${CMAKE_INSTALL_PREFIX}/lib )
endif()

# don't install libgrive for now
#install(TARGETS grive LIBRARY DESTINATION ${LIB_INSTALL_DIR} )
#install(TARGETS grive ARCHIVE DESTINATION ${LIB_INSTALL_DIR} )
#install(FILES ${DRIVE_HEADERS} DESTINATION include/grive/drive)
#install(FILES ${PROTOCOL_HEADERS} DESTINATION include/grive/protocol)
#install(FILES ${UTIL_HEADERS} DESTINATION include/grive/util)
#install(FILES ${XML_HEADERS} DESTINATION include/grive/xml)

IF ( CPPUNIT_FOUND )
	message("-- Building unitary tests along with the library and the binary")
	set( OPT_INCS		${CPPUNIT_INCLUDE_DIR} )
    
    # list of test source files here
	file(GLOB TEST_SRC
		test/drive/*.cc
		test/util/*.cc
		test/xml/*.cc
	)

	add_executable( unittest
		test/UnitTest.cc
		${TEST_SRC}
	)

	target_link_libraries( unittest
		grive
		${CPPUNIT_LIBRARY}
	)
        
ENDIF ( CPPUNIT_FOUND )

=== debian/changelog ===
grive (0.2.0-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Build-depend on libiberty-dev instead of binutils-dev
   (Closes: #725289, #730358)

 -- David Prévot <taffit@debian.org>  Mon, 23 Dec 2013 16:48:34 -0400

grive (0.2.0-1) unstable; urgency=low

  * First version for Debian (Closes: #675310)

 -- José Luis Segura Lucas <josel.segura@gmx.es>  Mon, 09 Jul 2012 07:54:24 +0200

=== debian/control ===
Source: grive
Section: net
Priority: extra
Maintainer: José Luis Segura Lucas <josel.segura@gmx.es>
Uploaders: Cleto Martín <cleto@debian.org>
Build-Depends: cmake,
               debhelper (>= 9),
               docbook-xsl,
               libboost-filesystem-dev,
               libboost-program-options-dev,
               libboost-system-dev,
               libcppunit-dev,
               libcurl4-gnutls-dev | libcurl-dev,
               libexpat-dev,
               libgcrypt-dev,
               libiberty-dev,
               libjson0-dev,
               xsltproc
Standards-Version: 3.9.3
Homepage: https://github.com/Grive/grive
Vcs-Git: git://github.com/JoseLSegura/Grive-Debian-packaging.git

Package: grive
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Google Drive client for GNU/Linux
 Grive is a Google Drive (an online storage service) client. It
 allows synchronize your Google Drive files with a directory on your
 local storage from the command-line.
 .
 It automatically synchronizes your local copy of your Google Drive,
 adding or removing files from the online storage. It allows add new
 files on your local directory and them will be uploaded to Google
 Drive when it synchronizes.
 .
 Grive is still in process of development. It will include support for
 auto-detecting changes on the local storage to force a
 synchronization and a daemon mode which will work on user space to
 have your local files always synchronized with your online storage.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

DEB_HOST_GNU_TYPE := $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
DB2MAN := /usr/share/xml/docbook/stylesheet/docbook-xsl/manpages/docbook.xsl

%:
	dh $@

override_dh_clean:
	dh_clean
	$(RM) debian/grive.1

override_dh_auto_build:
	dh_auto_build
	xsltproc -o debian/grive.1 --param man.charmap.use.subset "0" --novalid --nonet $(DB2MAN) debian/grive.xml

override_dh_auto_test:
	./obj-$(DEB_BUILD_GNU_TYPE)/libgrive/unittest

=== debian/watch ===
version=3

opts=filenamemangle=s/.*(\d[\d\.]+)/grive_$1\.tar\.gz/ \
  https://github.com/Grive/grive/tags .*/tarball/v?(\d[\d\.]+)
